diff -pruN 4.0-2/debian/changelog 4.0-3/debian/changelog
--- 4.0-2/debian/changelog	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/changelog	2021-01-18 20:58:52.000000000 +0000
@@ -1,3 +1,70 @@
+chrony (4.0-3) unstable; urgency=medium
+
+  * debian/:
+    - chronyd's configuration can now be fragmented. Please see
+    /etc/chrony/conf.d/README for more information.
+    - NTP sources can be specified in /etc/chrony/sources.d. Please see
+    /etc/chrony/sources.d/README for more information.
+
+  * debian/chrony.conf:
+    - Include configuration files found in /etc/chrony/conf.d.
+    - Use NTP sources found in /etc/chrony/sources.d.
+    - Get TAI-UTC offset and leap seconds from the system tz database by using
+    the "leapsectz right/UTC" directive. This directive must be commented out
+    when using time sources serving leap-smeared time. (Closes: #974845)
+    - Add missing comment.
+
+  * debian/chrony.default:
+    - Switch the seccomp filter to level 1.
+
+  * debian/chrony.lintian-overrides:
+    - Override breakout-link.
+
+  * debian/control:
+    - Add tzdata to the dependencies.
+    - Bump Standards-Version to 4.5.1 (no changes required).
+
+  * debian/copyright:
+    - Update copyright year for debian/*.
+
+  * debian/postinst:
+    - Use dpkg-statoverride to manage mode bits and ownership of
+    /var/l{ib,og}/chrony.
+
+  * debian/postrm:
+    - Remove overrides for /var/l{ib,og}/chrony on purge.
+
+  * debian/rules:
+    - Drop '--without-readline' option. GNU readline support has been dropped
+    upstream due to license incompatibility.
+    - Replace -F -1 by -F 1 in the sed invocation.
+
+  * debian/tests/:
+    - Add fragmented-configuration autopkgtest.
+    - Add dynamically-add-source autopkgtest.
+    - Add ntp-server-and-nts-auth autopkgtest.
+
+  * debian/tests/control:
+    - Mark ntp-server-and-nts-auth as skippable.
+
+  * debian/tests/fragmented-configuration:
+    - Use another directive for the test since "leapsectz right/UTC" is now
+    used by default.
+
+  * debian/tests/helper-functions:
+    - Add __no_system_clock_control() function.
+
+  * debian/tests/upstream-simulation-test-suite:
+    - Always use the same seed to get deterministic results.
+
+  * debian/upstream/metadata:
+    - Remove obsolete field Name. Thanks to Debian Janitor <janitor@jelmer.uk>.
+
+  * debian/usr.sbin.chronyd:
+    - Make use of the @{run} variable.
+
+ -- Vincent Blut <vincent.debian@free.fr>  Mon, 18 Jan 2021 21:58:52 +0100
+
 chrony (4.0-2) unstable; urgency=medium
 
   * Merge branch 'experimental' into 'master'.
diff -pruN 4.0-2/debian/chrony.conf 4.0-3/debian/chrony.conf
--- 4.0-2/debian/chrony.conf	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/chrony.conf	2021-01-18 20:58:52.000000000 +0000
@@ -1,10 +1,18 @@
 # Welcome to the chrony configuration file. See chrony.conf(5) for more
 # information about usable directives.
+
+# Include configuration files found in /etc/chrony/conf.d.
+confdir /etc/chrony/conf.d
+
+# Use Debian vendor zone.
 pool 2.debian.pool.ntp.org iburst
 
 # Use time sources from DHCP.
 sourcedir /run/chrony-dhcp
 
+# Use NTP sources found in /etc/chrony/sources.d.
+sourcedir /etc/chrony/sources.d
+
 # This directive specify the location of the file containing ID/key pairs for
 # NTP authentication.
 keyfile /etc/chrony/chrony.keys
@@ -32,3 +40,8 @@ rtcsync
 # Step the system clock instead of slewing it if the adjustment is larger than
 # one second, but only in the first three clock updates.
 makestep 1 3
+
+# Get TAI-UTC offset and leap seconds from the system tz database.
+# This directive must be commented out when using time sources serving
+# leap-smeared time.
+leapsectz right/UTC
diff -pruN 4.0-2/debian/chrony.default 4.0-3/debian/chrony.default
--- 4.0-2/debian/chrony.default	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/chrony.default	2021-01-18 20:58:52.000000000 +0000
@@ -3,4 +3,4 @@
 # the chrony daemon without editing the init script or service file.
 
 # Options to pass to chrony.
-DAEMON_OPTS="-F -1"
+DAEMON_OPTS="-F 1"
diff -pruN 4.0-2/debian/chrony.lintian-overrides 4.0-3/debian/chrony.lintian-overrides
--- 4.0-2/debian/chrony.lintian-overrides	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/chrony.lintian-overrides	2021-01-18 20:58:52.000000000 +0000
@@ -5,3 +5,7 @@ chrony: non-standard-file-perm usr/share
 # NetworkManager does not execute dispatcher scripts in /usr/libexec.
 chrony: executable-in-usr-lib usr/lib/NetworkManager/dispatcher.d/20-chrony-dhcp
 chrony: executable-in-usr-lib usr/lib/NetworkManager/dispatcher.d/20-chrony-onoffline
+
+# Being architecture-independent, these symlinks should be harmless.
+chrony: breakout-link usr/lib/networkd-dispatcher/off.d/chrony-onoffline -> usr/lib/NetworkManager/dispatcher.d/20-chrony-onoffline
+chrony: breakout-link usr/lib/networkd-dispatcher/routable.d/chrony-onoffline -> usr/lib/NetworkManager/dispatcher.d/20-chrony-onoffline
diff -pruN 4.0-2/debian/conf.d/README 4.0-3/debian/conf.d/README
--- 4.0-2/debian/conf.d/README	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-3/debian/conf.d/README	2021-01-18 20:58:52.000000000 +0000
@@ -0,0 +1,7 @@
+Files found under the /etc/chrony/conf.d directory with the .conf suffix are
+parsed in the lexicographical order of the file names when chronyd starts up.
+This enables a fragmented configuration of chronyd.
+
+Although those files can contain any directives listed in chrony.conf(5),
+it would be wiser to add NTP sources in the /etc/chrony/sources.d
+directory. Please read /etc/chrony/sources.d/README for more information.
diff -pruN 4.0-2/debian/control 4.0-3/debian/control
--- 4.0-2/debian/control	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/control	2021-01-18 20:58:52.000000000 +0000
@@ -3,7 +3,7 @@ Section: net
 Priority: optional
 Maintainer: Vincent Blut <vincent.debian@free.fr>
 Uploaders: Joachim Wiedorn <joodebian@joonet.de>
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Build-Depends: asciidoctor (>= 1.5.3-1~),
                bison,
                debhelper-compat (= 13),
@@ -28,6 +28,7 @@ Architecture: linux-any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: adduser,
          iproute2 [linux-any],
+         tzdata,
          ucf,
          ${misc:Depends},
          ${shlibs:Depends}
diff -pruN 4.0-2/debian/copyright 4.0-3/debian/copyright
--- 4.0-2/debian/copyright	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/copyright	2021-01-18 20:58:52.000000000 +0000
@@ -33,7 +33,7 @@ Copyright: 2001, J. Hannken-Illjes
 License: GPL-2
 
 Files: debian/*
-Copyright: 2015-2020, Vincent Blut
+Copyright: 2015-2021, Vincent Blut
            2012-2014, Joachim Wiedorn
            2000-2012, John Hasler
 License: GPL-2
diff -pruN 4.0-2/debian/install 4.0-3/debian/install
--- 4.0-2/debian/install	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/install	2021-01-18 20:58:52.000000000 +0000
@@ -1,5 +1,7 @@
 debian/chrony-dnssrv@.* lib/systemd/system
 debian/chrony-helper usr/libexec/chrony
 debian/chrony.conf usr/share/chrony
+debian/conf.d etc/chrony
 debian/ntp-units.d/50-chrony.list usr/lib/systemd/ntp-units.d
+debian/sources.d etc/chrony
 debian/usr.sbin.chronyd etc/apparmor.d
diff -pruN 4.0-2/debian/postinst 4.0-3/debian/postinst
--- 4.0-2/debian/postinst	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/postinst	2021-01-18 20:58:52.000000000 +0000
@@ -33,10 +33,15 @@ case "$1" in
             fi
         fi
 
-        # Change the user and group ownership of "/var/lib/chrony" iif the user
-        # has not set the "user" directive in chrony.conf
+        # Change the user and group ownership of "/var/l{ib,og}/chrony" iif
+        # the user has not set the "user" directive in chrony.conf. Also, update
+        # these directories' mode bits to 0750 to follow upstream.
         if ! grep -q "^user" /etc/chrony/chrony.conf 2> /dev/null; then
-            chown _chrony:_chrony /var/lib/chrony
+            for d in /var/lib/chrony /var/log/chrony; do
+                if ! dpkg-statoverride --list "$d" >/dev/null; then
+                    dpkg-statoverride --update --add _chrony _chrony 0750 "$d"
+                fi
+            done
         fi
 
         if [ -n "$2" ] && dpkg --compare-versions "$2" lt 4.0~pre4-1; then
diff -pruN 4.0-2/debian/postrm 4.0-3/debian/postrm
--- 4.0-2/debian/postrm	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/postrm	2021-01-18 20:58:52.000000000 +0000
@@ -30,6 +30,12 @@ case "$1" in
         then
             deluser --quiet --system _chrony > /dev/null 2>&1 || true
         fi
+
+        for d in /var/lib/chrony /var/log/chrony; do
+            if dpkg-statoverride --list "$d" >/dev/null; then
+                dpkg-statoverride --remove "$d"
+            fi
+        done
     ;;
 
     remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
diff -pruN 4.0-2/debian/rules 4.0-3/debian/rules
--- 4.0-2/debian/rules	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/rules	2021-01-18 20:58:52.000000000 +0000
@@ -15,7 +15,6 @@ BASE=debian/chrony
 override_dh_auto_configure:
 	dh_auto_configure --  --mandir=/usr/share/man \
 		--sysconfdir=/etc/chrony \
-		--without-readline \
 		--with-user=_chrony \
 		--enable-scfilter \
 		--chronyrundir=/run/chrony \
@@ -42,7 +41,7 @@ override_dh_installinit:
 # Disable the system call filter on architectures mentioned below
 # due to missing support in libseccomp and/or in the Linux kernel.
 ifneq (,$(filter $(DEB_HOST_ARCH), alpha ia64 m68k sh4 sparc64))
-	sed -i '/DAEMON_OPTS=/s/"-F -1"/""/' $(BASE)/etc/default/chrony
+	sed -i '/DAEMON_OPTS=/s/"-F 1"/""/' $(BASE)/etc/default/chrony
 endif
 
 override_dh_auto_test:
diff -pruN 4.0-2/debian/sources.d/README 4.0-3/debian/sources.d/README
--- 4.0-2/debian/sources.d/README	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-3/debian/sources.d/README	2021-01-18 20:58:52.000000000 +0000
@@ -0,0 +1,11 @@
+Only NTP sources can be specified in the /etc/chrony/sources.d directory.
+Files in this directory must end with the ".sources" suffix, and can only
+contain the "peer", "pool" and "server" directives.
+
+There is no need to restart chronyd for these time sources to be usable,
+running 'chronyc reload sources' is sufficient.
+
+Example:
+
+# echo 'server 192.0.2.1 iburst' > /etc/chrony/sources.d/local-ntp-server.sources
+# chronyc reload sources
diff -pruN 4.0-2/debian/tests/control 4.0-3/debian/tests/control
--- 4.0-2/debian/tests/control	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/tests/control	2021-01-18 20:58:52.000000000 +0000
@@ -15,3 +15,14 @@ Features: test-name=run_destructive_syst
 Test-Command: debian/tests/upstream-system-tests -d 1[0-9][0-9]-*
 Depends: @, @builddeps@, ethtool
 Restrictions: build-needed, isolation-machine, needs-root
+
+Tests: fragmented-configuration
+Restrictions: isolation-container, needs-root
+
+Tests: dynamically-add-source
+Depends: @, dpkg-dev
+Restrictions: isolation-container, needs-root
+
+Tests: ntp-server-and-nts-auth
+Depends: @, dpkg-dev, gnutls-bin
+Restrictions: isolation-container, needs-root, skippable
diff -pruN 4.0-2/debian/tests/dynamically-add-source 4.0-3/debian/tests/dynamically-add-source
--- 4.0-2/debian/tests/dynamically-add-source	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-3/debian/tests/dynamically-add-source	2021-01-18 20:58:52.000000000 +0000
@@ -0,0 +1,39 @@
+#!/bin/sh
+# Make sure that NTP sources from /etc/chrony/sources.d are usable.
+
+set -eu
+
+. debian/tests/helper-functions
+
+server_addr="192.0.2.1"
+
+check_sources() {
+    chronyc sources | grep -q "$server_addr" && __test_ok || __test_fail
+}
+
+reload_sources() {
+    chronyc reload sources > /dev/null 2>&1 && __test_ok || __test_fail
+}
+
+restart_chronyd() {
+    systemctl --quiet restart chrony.service
+}
+
+printf "Preparing chronyd configuration: "
+__no_system_clock_control && __test_ok || __test_fail
+
+printf "Adding a dummy server to the list of NTP sources: "
+printf "server $server_addr" > /etc/chrony/sources.d/dummy-server.sources && __test_ok || __test_fail
+
+printf "Reloading NTP sources: "
+reload_sources
+
+printf "Checking for dummy server availability: "
+check_sources
+
+printf "Checking for dummy server availability after restarting chronyd: "
+restart_chronyd
+sleep 2
+check_sources
+
+exit 0
diff -pruN 4.0-2/debian/tests/fragmented-configuration 4.0-3/debian/tests/fragmented-configuration
--- 4.0-2/debian/tests/fragmented-configuration	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-3/debian/tests/fragmented-configuration	2021-01-18 20:58:52.000000000 +0000
@@ -0,0 +1,17 @@
+#!/bin/sh
+# Make sure that fragmented configuration works as expected.
+
+set -e
+
+. debian/tests/helper-functions
+
+printf 'Setting "authselectmode prefer" as authentication policy: '
+echo "authselectmode prefer" > /etc/chrony/conf.d/authentication-policy.conf && __test_ok || __test_fail
+
+printf "Restart chronyd: "
+systemctl --quiet restart chrony.service && __test_ok || __test_fail
+
+printf "Checking that chronyd uses the defined authentication policy: "
+chronyd -p 2> /dev/null | grep -q "authselectmode prefer" && __test_ok || __test_fail
+
+exit 0
diff -pruN 4.0-2/debian/tests/helper-functions 4.0-3/debian/tests/helper-functions
--- 4.0-2/debian/tests/helper-functions	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/tests/helper-functions	2021-01-18 20:58:52.000000000 +0000
@@ -1,3 +1,15 @@
+__no_system_clock_control() {
+    if ! dpkg-vendor --derives-from Ubuntu; then
+        sed -i '/^DAEMON_OPTS=/s/"\(.*\)"/"\1 -x"/' /etc/default/chrony
+        mkdir -p /etc/systemd/system/chrony.service.d
+        cat <<EOF > /etc/systemd/system/chrony.service.d/override.conf
+[Unit]
+ConditionCapability=
+EOF
+        systemctl daemon-reload && systemctl --quiet restart chrony.service
+    fi
+}
+
 __test_fail() {
     printf 'FAIL\n' >&2
     return 1
diff -pruN 4.0-2/debian/tests/ntp-server-and-nts-auth 4.0-3/debian/tests/ntp-server-and-nts-auth
--- 4.0-2/debian/tests/ntp-server-and-nts-auth	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-3/debian/tests/ntp-server-and-nts-auth	2021-01-18 20:58:52.000000000 +0000
@@ -0,0 +1,58 @@
+#!/bin/sh
+# Check that chronyd is able to authenticate NTP packets when NTS is enabled
+# on the server.
+
+set -eu
+
+. debian/tests/helper-functions
+
+cert_dir="/var/lib/chrony"
+cert_template="$cert_dir/cert.cfg"
+cert_file="$cert_dir/server.crt"
+priv_key="$cert_dir/server.key"
+server_addr="127.0.1.1"
+server_name="chrony-nts-test"
+
+create_cert_template() {
+    printf "Creating certificate template: "
+    cat <<EOF > "$cert_template"
+cn = "$server_name"
+serial = 001
+activation_date = "$(date -d '1 year ago' +'%Y-%m-%d') 00:00:00 UTC"
+expiration_date = "$(date -d '1 year' +'%Y-%m-%d') 00:00:00 UTC"
+signing_key
+encryption_key
+EOF
+}
+
+generate_cert() {
+    printf "Generating self-signed certificate: "
+    certtool --generate-privkey --key-type=ed25519 --outfile "$priv_key" > /dev/null 2>&1
+    certtool --generate-self-signed --load-privkey "$priv_key" --template "$cert_template" \
+        --outfile "$cert_file" > /dev/null 2>&1
+}
+
+server_config() {
+    printf "Preparing chronyd configuration: "
+    cat <<EOF > /etc/chrony/conf.d/local-server-config.conf
+server $server_name nts minpoll -6 maxpoll -6
+ntsserverkey $priv_key
+ntsservercert $cert_file
+ntstrustedcerts $cert_file
+EOF
+
+    __no_system_clock_control
+}
+
+echo "$server_addr $server_name" >> /etc/hosts
+
+create_cert_template && __test_ok || __test_skip "unable to create certificate template"
+
+generate_cert && __test_ok || __test_skip "unable to generate self-signed certificate"
+
+server_config && __test_ok || __test_fail
+
+printf "Checking if server authenticates NTP packets: "
+chronyc -c authdata | grep -q "$server_addr,NTS" && __test_ok || __test_fail
+
+exit 0
diff -pruN 4.0-2/debian/tests/upstream-simulation-test-suite 4.0-3/debian/tests/upstream-simulation-test-suite
--- 4.0-2/debian/tests/upstream-simulation-test-suite	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/tests/upstream-simulation-test-suite	2021-01-18 20:58:52.000000000 +0000
@@ -13,6 +13,9 @@ clknetsim_archive=$(basename "$clknetsim
 
 export CLKNETSIM_PATH="$AUTOPKGTEST_TMP"
 
+# Always use the same seed to get deterministic results
+export CLKNETSIM_RANDOM_SEED=24505
+
 DEB_HOST_MULTIARCH=$(dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 # The simulation tests are only supported on Linux.
diff -pruN 4.0-2/debian/upstream/metadata 4.0-3/debian/upstream/metadata
--- 4.0-2/debian/upstream/metadata	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/upstream/metadata	2021-01-18 20:58:52.000000000 +0000
@@ -1,4 +1,3 @@
-Name: chrony
 Documentation: https://chrony.tuxfamily.org/documentation.html
 Changelog: https://chrony.tuxfamily.org/news.html
 FAQ: https://chrony.tuxfamily.org/faq.html
diff -pruN 4.0-2/debian/usr.sbin.chronyd 4.0-3/debian/usr.sbin.chronyd
--- 4.0-2/debian/usr.sbin.chronyd	2020-10-13 13:59:33.000000000 +0000
+++ 4.0-3/debian/usr.sbin.chronyd	2021-01-18 20:58:52.000000000 +0000
@@ -41,8 +41,8 @@
   /etc/chrony/{,**} r,
   /var/lib/chrony/{,*} rw,
   /var/log/chrony/{,*} rw,
-  /{,var/}run/chrony/{,*} rw,
-  /{,var/}run/chrony-dhcp/{,*} r,
+  @{run}/chrony/{,*} rw,
+  @{run}/chrony-dhcp/{,*} r,
 
   # Using the “tempcomp” directive gives chronyd the ability to improve
   # the stability and accuracy of the clock by compensating the temperature
@@ -54,8 +54,8 @@
   # are common use cases; others should be set as local include (see below).
   # Configs using a 'chrony.' prefix like the tempcomp config file example
   /etc/chrony.* r,
-  # Example gpsd socket is outside /{,var/}run/chrony/
-  /{,var/}run/chrony.tty{,*}.sock rw,
+  # Example gpsd socket is outside @{run}/chrony/
+  @{run}/chrony.tty{,*}.sock rw,
   # To sign replies to MS-SNTP clients by the smbd daemon
   /var/lib/samba/ntp_signd/socket rw,
 
